﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using CheeseReminder.Resources;

using Windows.Phone.Speech.VoiceCommands;
using System.Globalization;

namespace CheeseReminder
{
    public partial class MainPage : PhoneApplicationPage
    {

        #region Voice Command Setup

        string[] supportLangauges = new string[] { "en-us", "en-gb" };

        bool checkLanguage()
        {
            string language = CultureInfo.CurrentCulture.Name.ToLower();

            foreach (string supportedLanguage in supportLangauges)
            {
                if (language == supportedLanguage) return true;
            }

            MessageBox.Show("Missing Languge" + Environment.NewLine + Environment.NewLine +
                            "No support for: " + CultureInfo.CurrentCulture.DisplayName +
                            Environment.NewLine + Environment.NewLine +
                            "Sorry about that.");
            return false;
        }

        async void setupVoiceCommands()
        {
            string language = CultureInfo.CurrentCulture.Name.ToLower();

            if (!checkLanguage())
            {
                return;
            }

            await VoiceCommandService.InstallCommandSetsFromFileAsync(
                new Uri("ms-appx:///VoiceCommandDefinition.xml", UriKind.RelativeOrAbsolute));
        }

        #endregion


        // Constructor
        public MainPage()
        {
            InitializeComponent();

            // Sample code to localize the ApplicationBar
            //BuildLocalizedApplicationBar();
        }

        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            base.OnNavigatedTo(e);
            setupVoiceCommands();
            StatusTextBlock.Text = ReminderManager.GetStatus("Cheese Reminder");
        }

        // Sample code for building a localized ApplicationBar
        //private void BuildLocalizedApplicationBar()
        //{
        //    // Set the page's ApplicationBar to a new instance of ApplicationBar.
        //    ApplicationBar = new ApplicationBar();

        //    // Create a new button and set the text value to the localized string from AppResources.
        //    ApplicationBarIconButton appBarButton = new ApplicationBarIconButton(new Uri("/Assets/AppBar/appbar.add.rest.png", UriKind.Relative));
        //    appBarButton.Text = AppResources.AppBarButtonText;
        //    ApplicationBar.Buttons.Add(appBarButton);

        //    // Create a new menu item with the localized string from AppResources.
        //    ApplicationBarMenuItem appBarMenuItem = new ApplicationBarMenuItem(AppResources.AppBarMenuItemText);
        //    ApplicationBar.MenuItems.Add(appBarMenuItem);
        //}
    }
}