﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;

namespace CheeseReminder
{
    public partial class ReminderSetPage : PhoneApplicationPage
    {
        public ReminderSetPage()
        {
            InitializeComponent();
        }

        struct numberDecode
        {
            public string Text;
            public int Value;
            public numberDecode(string inText, int inValue)
            {
                Text = inText;
                Value = inValue;
            }
        }

        numberDecode[] numbers = new[] { 
          new numberDecode("one",1),
          new numberDecode("two",2),
          new numberDecode("three",3),
          new numberDecode("four",4),
          new numberDecode("five",5),
          new numberDecode("six",6),
          new numberDecode("seven",7),
          new numberDecode("eight",8),
          new numberDecode("nine",9),
          new numberDecode("ten",10),
          new numberDecode("eleven",11),
          new numberDecode("twelve",12),
          new numberDecode("thirteen",13),
          new numberDecode("fourteen",14),
          new numberDecode("fifteen",15),
          new numberDecode("twenty",20),
          new numberDecode("twenty five",25),
          new numberDecode("thirty",30),
          new numberDecode("thirty five",35),
          new numberDecode("forty",40),
          new numberDecode("forty five",45),
          new numberDecode("fifty",50),
          new numberDecode("fifty five",55)
        };

        int lookUpNumber(string number)
        {
            for (int i = 0; i < numbers.Length; i++)
            {
                if (numbers[i].Text == number)
                    return numbers[i].Value;
            }
            throw new Exception("Voice number not found");
        }

        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            base.OnNavigatedTo(e);

            // Is this a new activation or a resurrection from tombstone?
            if (e.NavigationMode == System.Windows.Navigation.NavigationMode.New)
            {
                // Was the application launched using a Voice Command?
                if (NavigationContext.QueryString.ContainsKey("voiceCommandName"))
                {
                    // If so, get the name of the Voice Command.
                    string voiceCommandName = NavigationContext.QueryString["voiceCommandName"];

                    switch (voiceCommandName)
                    {
                        case "SetReminder":
                            string delayNumberString = NavigationContext.QueryString["number"];
                            int delay = lookUpNumber(delayNumberString);
                            string delayUnits = NavigationContext.QueryString["units"];

                            if ( delayUnits == "hours" || delayUnits == "hour") delay = delay*60;

                            ReminderManager.SetReminder(delay, "Cheese Reminder");
                            StatusTextBlock.Text = ReminderManager.GetStatus("Cheese Reminder");
                            break;
                    }
                }
            }
        }
    }
}